public class Node  
{
    public final Point position;//position of the node, should never change
    private Point destination;//where its leading to
    private Node parent;//where this node came from
    private int gValue;
    private int hValue;
    public Node(Point current, Node parent, Point end)
    {
        position = current;
        destination = end;
        this.parent = parent;
        if(parent != null)
        {
            if((int)(Math.abs(position.getX() - parent.position.getX())) == 1 && (int)(Math.abs(position.getY() - parent.position.getY())) == 1)//diagnal to parent
            {gValue = 14;}
            else//horizontal/verticle
            {gValue = 10;}
            gValue += parent.gValue;
        }
        else//parent is null == no parent
        {
            gValue = 0;
        }
        hValue = (int)(Math.abs(position.getX() - destination.getX()) + Math.abs(position.getY() - destination.getY())) * 10;
    }
    public boolean isOn(Point n)//is this node located on point n?
    {
        return position.getX() == n.getX() && position.getY() == n.getY();
    }
    public boolean is(Node n)//if node's position is the same, they are the same node
    {
        return position.is(n.position);
    }
    public void setDestination(Point end)
    {
        destination = end;
        hValue = (int)(Math.abs(position.getX() - destination.getX()) + Math.abs(position.getY() - destination.getY())) * 10;//recalculate h value
    }
    public void adopt(Node p)//changes the parent
    {
        parent = p;
        if(p != null)
        {
            if((int)(Math.abs(position.getX() - p.position.getX())) == 1 && (int)(Math.abs(position.getY() - p.position.getY())) == 1)//horizontal to parent
            {gValue = 14;}
            else
            {gValue = 10;}
            gValue = p.gValue + gValue;
        }
        else
        {
            gValue = 0;
        }
    }
    public boolean biggerG(Node p)//return true if this g is bigger then new g
    {
        int gValue2 = 0;
        if((int)(Math.abs(position.getX() - p.position.getX())) == 1 && (int)(Math.abs(position.getY() - p.position.getY())) == 1)//horizontal to p
        {gValue2 = 14;}
        else
        {gValue2 = 10;}
        gValue2 = p.gValue + gValue2;
        return gValue > gValue2;
    }
    public int getH()
    {
        return hValue;
    }
    public int getG()
    {
        return gValue;
    }
    public int getF()
    {
        return gValue + hValue;
    }
    public Node getParent()
    {
        return parent;
    }
}
