import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)  
import java.lang.Math;  

public class SmoothMover extends Actor  
{  
    public double currentX;  
    public double currentY;  
    public void addedToWorld(World world)  
    {  
        currentX = getX();  
        currentY = getY();  
    }  
  
    public void move(double speed)  
    {  
        int angle = getRotation();  
        double vectorX = Math.cos(((double)angle)*Math.PI/180.0)*(double)speed;  
        double vectorY = Math.sin(((double)angle)*Math.PI/180.0)*(double)speed; 
        
        if(isInsideWorld(currentX+vectorX, currentY+vectorY))
        {
            currentX += vectorX;  
            currentY += vectorY;  
            setLocation((int)currentX, (int)currentY);  
        }
    }  
  
    private boolean isInsideWorld(double x, double y)  
    {  
        Field w = (Field)getWorld();
        /*
        if ((int)x <= 0 || (int)x >= w.getWidth()-1) return false;  
        if ((int)y <= 0 || (int)y >= w.getHeight()-1) return false;  
        return true;  
        */
        return (((int)x > 0 && (int)x < w.getWidth() - 1) && ((int)y > 0 && (int)y < w.getHeight() - 1));
    }  
}  
