import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Color;
/**
 * Write a description of class Units here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Units extends PathFinder implements Moveable, Killable, Selectable
{
    public boolean selected;//being selected and being deselected is determined in the (Field)world class
    public boolean attack;//attack moveing, if attack == true will stop to attack stuff
    public Killable target;//the target that this unit is trying to attack
    
    public double pushX;
    public double pushY;
    public int r;
    public double mass;
    
    public GreenfootImage image;
    
    public int side;//whose side are you on?//0 = red, 1 = sand, 2 = purple
    public int sight;//can see this far
    public int attackRange;//can attack if within this range
    public int chaseRange;//a number between sight and attackRange, out of attack range but will *chase after it* till in attack range
    public int hp;//health
    
    private int attackTimer;
    public Units(int side)//currently only 2 sides
    {
        super();
        speed = 0.5;
        mass = 1.0;
        pushX = 0;
        pushY = 0;
        sight = 80;
        attackRange = 60;
        this.side = side;
        if(side == 0)
        {
            image = new GreenfootImage("Dot.png");
        }
        else
        {
            image = new GreenfootImage("Dot1.png");
        }
        setImage(image);
        r = getImage().getWidth()/2;//should put this after set image!!!
        selected = false;
    }
    public void act() 
    {
        //see();
        if(getNearestEnemy() != null && attackTimer > 50)//attack shit
        {
            shoot(getNearestEnemy());
            attackTimer = 0;
        }
        attackTimer ++;
    }  
    public boolean selected()
    {
        return selected;
    }
    public void move(int x, int y)
    {
        attack = false;
        destination.setPoint(x, y);
        Field w = (Field)getWorld();
        w.joinQue(this);
        //havePath = false;
    }
    public void attackMove(int x, int y)
    {
        attack = true;
        destination.setPoint(x, y);
        Field w = (Field)getWorld();
        w.joinQue(this);
        //havePath = false;
    }
    public void see()
    {
        List<Fog> list = getObjectsInRange(sight, Fog.class);
        int size = list.size();
        for(int n = 0; n < size; n ++)
        {
            Fog f = list.get(n);
            f.visible();
            f.visited = true;
        }
    }
    public void select()
    {
        selected = true;
        GreenfootImage img = new GreenfootImage(image);
        img.setColor(Color.WHITE);
        img.drawOval(0,0,img.getWidth()-1,img.getHeight()-1);
        setImage(img);
    }
    public void deselect()
    {
        selected = false;
        setImage(image);
    }
    //-----------------------------------------------------------
    //collision stuff
    public void determinePushVectors()
    {
        pushX = 0;
        pushY = 0;
        List<Moveable> list = getIntersectingObjects(Moveable.class);
        int size = list.size();
        for(int n = 0; n < size; n ++)
        {
            Moveable a = list.get(n);
            double x2 = a.getCurrentX();
            double y2 = a.getCurrentY();
            
            double d = Math.sqrt((x2 - currentX)*(x2 - currentX) + (y2 - currentY)*(y2 - currentY));
            if(d < r + a.getRadius())//distance between center is less then their radius combined
            {
                //get angle up date push x and y
                double angle = Math.atan2((y2-currentY), (x2-currentX));
                double move = (r + a.getRadius()) - d;//gets how much the circles intersect
                pushX += Math.cos(angle)*(move/((mass + a.getMass())/a.getMass()));
                pushY += Math.sin(angle)*(move/((mass + a.getMass())/a.getMass()));
            }
        }
    }
    public void displace()
    {
        Field w = (Field)getWorld();
        currentY -= pushY;
        currentX -= pushX;
        setLocation((int)currentX, (int)currentY);
        if(currentX <= r || currentX > w.getWidth()-r)// x cord is out of bounds
        {
            currentX += pushX;
        }
        if(currentY <= r || currentY > w.getHeight()-r)// y cord is out of bounds
        {
            currentY += pushY;
        }
        setLocation((int)currentX, (int)currentY);
    }
    public int getRadius()
    {
        return r;
    }
    public double getCurrentX()
    {
        return currentX;
    }
    public double getCurrentY()
    {
        return currentY;
    }
    public double getMass()
    {
        return mass;
    }
    //----------------------------------------------------------------------------------------------
    //combat stuff
    public Killable getNearestEnemy()
    {
        List<Units> list = getObjectsInRange(attackRange, Units.class);
        int size = list.size();
        int distance = attackRange;
        int x = getX();
        int y = getY();
        if(!list.isEmpty())
        {
            Units nearest = null;
            for(int n = 0; n < size; n++)
            {
                Units test = list.get(n);
                if(test.side != side)//only scan for units which are on opposing factions
                {
                    int x2 = test.getX();
                    int y2 = test.getY();
                    int d = (int)Math.sqrt((Math.pow((x2 - x), 2) + Math.pow((y2 - y), 2)));
                    if(d < distance)
                    {
                        nearest = test;
                        distance = d;
                    }
                }
            }
            return nearest;
        }
        return null;
    }
    public void shoot(Killable k)
    {
        Projectiles arrow = new Projectiles(k);
        getWorld().addObject(arrow, getX(), getY());
    }
    public int getHp()
    {
        return hp;
    }
    public void die()
    {
        getWorld().removeObject(this);
    }
    public void takeDamage(int n)
    {
        hp -= n;
    }
}
