import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.lang.Math;
public class Wall extends Actor
{
    public int l;
    public Wall()
    {
        l = getImage().getWidth()/2;
    }
    public void act() 
    {
        collide();
    }   
    private void collide()//only collides with units
    {
        List<Units> list = getIntersectingObjects(Units.class);
        int size = list.size();
        for(int n = 0; n < size; n ++)
        {
            Units u = list.get(n);
            
            int hori = 0;
            int vert = 0;
            int pushVert = 0;
            int pushHori = 0;
            
            hori = (int)u.currentX - getX();
            vert = (int)u.currentY - getY();
            
            if(Math.abs(hori) > Math.abs(vert))//push horizontally
            {
                pushHori = (l + u.r - Math.abs(hori));
                if(hori < 0)//to the left
                {
                    pushHori *= -1;
                }
            }
            else
            {
                pushVert = (l + u.r - Math.abs(vert));
                if(vert < 0)//up
                {
                    pushVert *= -1;
                }
            }
            
            u.currentX = u.currentX + pushHori;
            u.currentY = u.currentY + pushVert;
            u.setLocation((int)u.currentX, (int)u.currentY);
        }
    }
}
